---
title: Set
slug: Web/JavaScript/Reference/Global_Objects/Set
tags:
  - Class
  - ECMAScript 2015
  - Global Objects
  - JavaScript
  - Object
  - Reference
  - set
---
<div>{{JSRef}}</div>

<p><span class="seoSummary">The <strong><code>Set</code></strong> object lets you store unique values of any type, whether {{Glossary("Primitive", "primitive values")}} or object references.</span></p>

<h2 id="Description">Description</h2>

<p><code>Set</code> objects are collections of values. You can iterate through the elements of a set in insertion order. A value in the <code>Set</code> <strong>may only occur once</strong>; it is unique in the <code>Set</code>'s collection.</p>

<h3 id="Value_equality">Value equality</h3>

<p>Because each value in the <code>Set</code> has to be unique, the value equality will be checked. In an earlier version of ECMAScript specification, this was not based on the same algorithm as the one used in the <code>===</code> operator. Specifically, for <code>Set</code>s, <code>+0</code> (which is strictly equal to <code>-0</code>) and <code>-0</code> were different values. However, this was changed in the ECMAScript 2015 specification. See <em>"Key equality for -0 and 0"</em> in the <a href="#Browser_compatibility">browser compatibility</a> table for details.</p>

<p>{{jsxref("NaN")}} and {{jsxref("undefined")}} can also be stored in a Set. All <code>NaN</code> values are equated (i.e. <code>NaN</code> is considered the same as <code>NaN</code>, even though <code>NaN !== NaN</code>).</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{jsxref("Set/Set", "Set()")}}</dt>
 <dd>Creates a new <code>Set</code> object.</dd>
</dl>

<h2 id="Static_properties">Static properties</h2>

<dl>
 <dt>{{jsxref("Set.@@species", "get Set[@@species]")}}</dt>
 <dd>The constructor function that is used to create derived objects.</dd>
</dl>

<h2 id="Instance_properties">Instance properties</h2>

<dl>
 <dt>{{jsxref("Set.prototype.size")}}</dt>
 <dd>Returns the number of values in the <code>Set</code> object.</dd>
</dl>

<h2 id="Instance_methods">Instance methods</h2>

<dl>
 <dt>{{jsxref("Set.add", "Set.prototype.add(<var>value</var>)")}}</dt>
 <dd>Appends <code><var>value</var></code> to the <code>Set</code> object. Returns the <code>Set</code> object with added value.</dd>
 <dt>{{jsxref("Set.prototype.clear()")}}</dt>
 <dd>Removes all elements from the <code>Set</code> object.</dd>
 <dt>{{jsxref("Set.delete", "Set.prototype.delete(<var>value</var>)")}}</dt>
 <dd>Removes the element associated to the <code><var>value</var></code> and returns a boolean asserting whether an element was successfully removed or not. <code>Set.prototype.has(<var>value</var>)</code> will return <code>false</code> afterwards.</dd>
 <dt>{{jsxref("Set.has", "Set.prototype.has(<var>value</var>)")}}</dt>
 <dd>Returns a boolean asserting whether an element is present with the given value in the <code>Set</code> object or not.</dd>
</dl>

<h3 id="Iteration_methods">Iteration methods</h3>

<dl>
 <dt>{{jsxref("Set.prototype.@@iterator()", "Set.prototype[@@iterator]()")}}</dt>
 <dd>Returns a new <code>Iterator</code> object that yields the <strong>values</strong> for each element in the <code>Set</code> object in insertion order.</dd>
 <dt>{{jsxref("Set.prototype.keys()")}}</dt>
 <dd>Returns a new <code>Iterator</code> object that yields the values for each element in the <code>Set</code> object in insertion order. (For Sets, this is the same as the <strong><code>values()</code></strong> method.)</dd>
 <dt>{{jsxref("Set.prototype.values()")}}</dt>
 <dd>Returns a new <code>Iterator</code> object that yields the <strong>values</strong> for each element in the <code>Set</code> object in insertion order. (For Sets, this is the same as the <strong><code>keys()</code></strong> method.)</dd>
 <dt>{{jsxref("Set.prototype.entries()")}}</dt>
 <dd>
 <p>Returns a new <code>Iterator</code> object that contains<strong> an array of <code>[<var>value</var>, <var>value</var>]</code></strong> for each element in the <code>Set</code> object, in insertion order.</p>

 <p>This is similar to the {{jsxref("Map")}} object, so that each entry's <em>key</em> is the same as its <em>value</em> for a <code>Set</code>.</p>
 </dd>
 <dt>{{jsxref("Set.forEach", "Set.prototype.forEach(<var>callbackFn</var>[, <var>thisArg</var>])")}}</dt>
 <dd>Calls <code><var>callbackFn</var></code> once for each value present in the <code>Set</code> object, in insertion order. If a <code><var>thisArg</var></code> parameter is provided, it will be used as the <code>this</code> value for each invocation of <code><var>callbackFn</var></code>.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Using_the_Set_object">Using the Set object</h3>

<pre class="brush: js notranslate">let mySet = new Set()

mySet.add(1)           // Set [ 1 ]
mySet.add(5)           // Set [ 1, 5 ]
mySet.add(5)           // Set [ 1, 5 ]
mySet.add('some text') // Set [ 1, 5, 'some text' ]
let o = {a: 1, b: 2}
mySet.add(o)

mySet.add({a: 1, b: 2})   // o is referencing a different object, so this is okay

mySet.has(1)              // true
mySet.has(3)              // false, since 3 has not been added to the set
mySet.has(5)              // true
mySet.has(Math.sqrt(25))  // true
mySet.has('Some Text'.toLowerCase()) // true
mySet.has(o)       // true

mySet.size         // 5

mySet.delete(5)    // removes 5 from the set
mySet.has(5)       // false, 5 has been removed

mySet.size         // 4, since we just removed one value

console.log(mySet)
// logs Set(4) [ 1, "some text", {…}, {…} ] in Firefox
// logs Set(4) { 1, "some text", {…}, {…} } in Chrome
</pre>

<h3 id="Iterating_Sets">Iterating Sets</h3>

<pre class="brush: js notranslate">// iterate over items in set
// logs the items in the order: 1, "some text", {"a": 1, "b": 2}, {"a": 1, "b": 2}
for (let item of mySet) console.log(item)

// logs the items in the order: 1, "some text", {"a": 1, "b": 2}, {"a": 1, "b": 2}
for (let item of mySet.keys()) console.log(item)

// logs the items in the order: 1, "some text", {"a": 1, "b": 2}, {"a": 1, "b": 2}
for (let item of mySet.values()) console.log(item)

// logs the items in the order: 1, "some text", {"a": 1, "b": 2}, {"a": 1, "b": 2}
// (key and value are the same here)
for (let [key, value] of mySet.entries()) console.log(key)

// convert Set object to an Array object, with <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/from">Array.from</a>
let myArr = Array.from(mySet) // [1, "some text", {"a": 1, "b": 2}, {"a": 1, "b": 2}]

// the following will also work if run in an HTML document
mySet.add(document.body)
mySet.has(document.querySelector('body')) // true

// converting between Set and Array
mySet2 = new Set([1, 2, 3, 4])
mySet2.size                    // 4
[...mySet2]                    // [1, 2, 3, 4]

// intersect can be simulated via
let intersection = new Set([...set1].filter(x =&gt; set2.has(x)))

// difference can be simulated via
let difference = new Set([...set1].filter(x =&gt; !set2.has(x)))

// Iterate set entries with forEach()
mySet.forEach(function(value) {
  console.log(value)
})

// 1
// 2
// 3
// 4</pre>

<h3 id="Implementing_basic_set_operations">Implementing basic set operations</h3>

<pre class="brush: js notranslate">function isSuperset(set, subset) {
    for (let elem of subset) {
        if (!set.has(elem)) {
            return false
        }
    }
    return true
}

function union(setA, setB) {
    let _union = new Set(setA)
    for (let elem of setB) {
        _union.add(elem)
    }
    return _union
}

function intersection(setA, setB) {
    let _intersection = new Set()
    for (let elem of setB) {
        if (setA.has(elem)) {
            _intersection.add(elem)
        }
    }
    return _intersection
}

function symmetricDifference(setA, setB) {
    let _difference = new Set(setA)
    for (let elem of setB) {
        if (_difference.has(elem)) {
            _difference.delete(elem)
        } else {
            _difference.add(elem)
        }
    }
    return _difference
}

function difference(setA, setB) {
    let _difference = new Set(setA)
    for (let elem of setB) {
        _difference.delete(elem)
    }
    return _difference
}

// Examples
let setA = new Set([1, 2, 3, 4])
let setB = new Set([2, 3])
let setC = new Set([3, 4, 5, 6])

isSuperset(setA, setB)          // =&gt; true
union(setA, setC)               // =&gt; Set [1, 2, 3, 4, 5, 6]
intersection(setA, setC)        // =&gt; Set [3, 4]
symmetricDifference(setA, setC) // =&gt; Set [1, 2, 5, 6]
difference(setA, setC)          // =&gt; Set [1, 2]

</pre>

<h3 id="Relation_with_Array_objects">Relation with Array objects</h3>

<pre class="brush: js notranslate">let myArray = ['value1', 'value2', 'value3']

// Use the regular Set constructor to transform an Array into a Set
let mySet = new Set(myArray)

mySet.has('value1')     // returns true

// Use the spread operator to transform a set into an Array.
console.log([...mySet]) // Will show you exactly the same Array as myArray
</pre>

<h3 id="Remove_duplicate_elements_from_the_array">Remove duplicate elements from the array</h3>

<pre class="brush: js notranslate">// Use to remove duplicate elements from the array

const numbers = [2,3,4,4,2,3,3,4,4,5,5,6,6,7,5,32,3,4,5]

console.log([...new Set(numbers)])

// [2, 3, 4, 5, 6, 7, 32]</pre>

<h3 id="Relation_with_Strings">Relation with Strings</h3>

<pre class="brush: js notranslate">let text = 'India'

let mySet = new Set(text)  // Set ['I', 'n', 'd', 'i', 'a']
mySet.size  // 5

//case sensitive &amp; duplicate ommision
new Set("Firefox")  // Set(7) [ "F", "i", "r", "e", "f", "o", "x" ]
new Set("firefox")  // Set(6) [ "f", "i", "r", "e", "o", "x" ]
</pre>

<h3 id="Use_Set_to_ensure_the_uniqueness_of_a_list_of_values">Use Set to ensure the uniqueness of a list of values</h3>

<pre class="brush: js notranslate" dir="ltr">const array = Array
  .from(document.querySelectorAll('[id]'))
  .map(function(e) {
      return e.id
  });

const set = new Set(array);
console.assert(set.size == array.length);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-set-objects', 'Set')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Set")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Map")}}</li>
 <li>{{jsxref("WeakMap")}}</li>
 <li>{{jsxref("WeakSet")}}</li>
</ul>
